//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "UScratchPad.h"
#include "About.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainForm *MainForm;
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
        : TForm(Owner)
{
 nameForm = " 1.0";
 Caption = nameForm + "  <new>";
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FileSaveAsClick(TObject *Sender)
{
 if(!MemoEdit->Lines->Count) {
   int result = Application->MessageBox(
     " !   ?",
     " ",
     MB_YESNOCANCEL | MB_ICONSTOP);
   if(result != IDYES)
     return;
 }

 SaveDialog->Title = "    ..."; 
 if(SaveDialog->Execute()) {
   MemoEdit->Lines->SaveToFile(SaveDialog->FileName);
   MemoEdit->Modified = false;
 }

 AnsiString name = SaveDialog->FileName;
 int pos = LastDelimiter("\\", name);
 if(IsPathDelimiter(name, pos)){
   name = name.Delete(1, pos);
 }

 Caption = nameForm + "  <" + name + ">";
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FileSaveClick(TObject *Sender)
{
 //   ,  SaveDialog
 if(SaveDialog->FileName == "")
   FileSaveAsClick(Sender);
 else {
   MemoEdit->Lines->SaveToFile(SaveDialog->FileName);
   MemoEdit->Modified = false;
 }
}
//---------------------------------------------------------------------------


void __fastcall TMainForm::FileExitClick(TObject *Sender)
{
 if(MemoEdit->Modified){
   int result = Application->MessageBox(
     " ?",
     " ",
     MB_YESNOCANCEL | MB_ICONWARNING);
   if(result == IDYES)
     FileSaveClick(Sender);
   else if(result == IDCANCEL)
     return;
 }
 Close();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FileOpenClick(TObject *Sender)
{
//    
 if(MemoEdit->Modified) {
   int result = Application->MessageBox(
     " !  ?",
     " ",
     MB_YESNOCANCEL | MB_ICONWARNING);

   if(result == IDYES)
     FileSaveClick(Sender);
   else if(result == IDCANCEL)
     return;
 }

//      
 OpenDialog->Title = "    ";
 OpenDialog->FileName = "";//   
 if(OpenDialog->Execute()) {
   if(MemoEdit->Lines->Count > 0)
     MemoEdit->Clear();
   MemoEdit->Lines->LoadFromFile(OpenDialog->FileName);
   SaveDialog->FileName = OpenDialog->FileName;

   AnsiString name = SaveDialog->FileName;
   int pos = LastDelimiter("\\", name);
   if(IsPathDelimiter(name, pos)){
     name = name.Delete(1, pos);
   }

   Caption = nameForm + "  <" + name + ">";
 }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FileNewClick(TObject *Sender)
{
 //    
 if(MemoEdit->Modified) {
   int result = Application->MessageBox(
     " !  ?",
     " ",
     MB_YESNOCANCEL | MB_ICONWARNING);

   if(result == IDYES)
     FileSaveClick(Sender);
   else if(result == IDCANCEL)
     return;
 }

//   Memo
 if(MemoEdit->Lines->Count > 0)
   MemoEdit->Clear();

//     
 SaveDialog->FileName = "";
 Caption = nameForm + "  <new>";
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::EditUndoClick(TObject *Sender)
{
 SendMessage(MemoEdit->Handle, WM_UNDO, 0, 0);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::EditSelectAllClick(TObject *Sender)
{
 MemoEdit->SelectAll();        
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::EditCutClick(TObject *Sender)
{
 MemoEdit->CutToClipboard();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::EditCopyClick(TObject *Sender)
{
 MemoEdit->CopyToClipboard();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::EditPasteClick(TObject *Sender)
{
 MemoEdit->PasteFromClipboard();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::EditWordWrapClick(TObject *Sender)
{
 MemoEdit->WordWrap = !MemoEdit->WordWrap;
 EditWordWrap->Checked = MemoEdit->WordWrap;
 PopupWordWrap->Checked = MemoEdit->WordWrap;
 if(MemoEdit->WordWrap)
   MemoEdit->ScrollBars = ssVertical;
 else
   MemoEdit->ScrollBars = ssBoth;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::HelpAboutClick(TObject *Sender)
{
 AboutBox->ShowModal();  
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::OnHint(TObject *Sender)
{
 StatusBar->SimpleText = Application->Hint;  
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FormCreate(TObject *Sender)
{
 Application->OnHint = &OnHint;        
}
//---------------------------------------------------------------------------

